'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var autocomplete = require('@codemirror/autocomplete');
var lr = require('@lezer/lr');
var common = require('@lezer/common');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 13,
  states: "!WQYQPOOOhQPO'#CdOOQO'#Ci'#CiOOQO'#Ce'#CeQYQPOOOOQO,59O,59OOyQPO,59OOOQO-E6c-E6cOOQO1G.j1G.j",
  stateData: "![~O[OSPOS~ORQOSQOTQOVPO~ORQOSQOTQOUTOVPO~ORQOSQOTQOUWOVPO~O",
  goto: "u^PPPPPPPP_ePPPoXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Identifier String Boolean ) ( Application",
  maxTerm: 13,
  nodeProps: [
    [common.NodeProp.openedBy, 6,"("],
    [common.NodeProp.closedBy, 7,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "$W~R^XY}YZ}]^}pq}rs!`st!}xy#]yz#b}!O#g!Q![#g!]!^#{!c!}#g#R#S#g#T#o#g~!SS[~XY}YZ}]^}pq}~!cTOr!`rs!rs#O!`#O#P!w#P~!`~!wOS~~!zPO~!`~#QQ#Y#Z#W#h#i#W~#]OT~~#bOV~~#gOU~~#lTR~}!O#g!Q![#g!c!}#g#R#S#g#T#o#g~$QQP~OY#{Z~#{",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const taylorLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                Identifier: highlight.tags.variableName,
                VariableName: highlight.tags.variableName,
                Boolean: highlight.tags.bool,
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                Number: highlight.tags.number,
                "( )": highlight.tags.paren,
                "[ ]": highlight.tags.squareBracket,
                "{ }": highlight.tags.brace,
                "def! macrodef! let* fn*": highlight.tags.definitionKeyword,
                "quote mquote mquote-noparens quasiquoteexpand quasiquote macroexpand eval": highlight.tags.keyword,
                "try* catch* do if and or undefined?": highlight.tags.controlKeyword,
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
const taylorCompletion = (autocompleteList) => taylorLanguage.data.of({
    autocomplete: autocomplete.completeFromList(autocompleteList || [
        { label: "def!", type: "function" },
        { label: "macrodef!", type: "function" },
        { label: "let*", type: "function" },
        { label: "cons", type: "function" },
        { label: "concat", type: "function" },
        { label: "str", type: "function" }
    ])
});
function taylor(autocompleteList = []) {
    return new language.LanguageSupport(taylorLanguage, taylorCompletion(autocompleteList));
}

exports.taylor = taylor;
exports.taylorLanguage = taylorLanguage;
